package org.apidesign.demo.minesweeper;

import java.io.IOException;
import java.net.URI;
import java.util.logging.Logger;
import org.apidesign.html.brwsr.XtrnlBrwsrPrsntr;
import org.robovm.cocoatouch.foundation.NSURL;
import org.robovm.cocoatouch.uikit.UIWebView;
import org.robovm.objc.ObjCBlock;
import org.robovm.objc.block.VoidBlock;
import org.robovm.rt.bro.Bro;
import org.robovm.rt.bro.NativeObject;
import org.robovm.rt.bro.annotation.Bridge;
import org.robovm.rt.bro.annotation.Library;

/**
 *
 * @author jtulach
 */
@Library("dispatch")    
final class IBrwsrPrsntr extends XtrnlBrwsrPrsntr {
    private final UIWebView wv;
    
    static {
        Bro.bind();
    }

    public static class Queue extends NativeObject {
    }

    @Bridge(symbol = "dispatch_get_current_queue")
    public static native Queue getMainQueue();

    @Bridge(symbol = "dispatch_async")
    public static native void async(Queue queue, ObjCBlock block);

    public IBrwsrPrsntr(UIWebView wv) throws Exception {
        this.wv = wv;
    }

    @Override
    public void runSafe(final Runnable r) {
        VoidBlock vb = new VoidBlock() {
            @Override
            public void invoke() {
                r.run();
            }
        };
        ObjCBlock ocb = VoidBlock.Marshaler.toObjCBlock(vb);
        async(getMainQueue(), ocb);
    }
    
    @Override
    protected void showBrwsr(URI page) throws IOException {
        wv.loadRequest(Foo.requestWithURL(new NSURL(page.toString())));
    }
    private static final Logger LOG = Logger.getLogger(IBrwsrPrsntr.class.getName());
    
}
